/*
  Copyright 2005 Damien Stehlé.

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along
  with this program; see the file COPYING.  If not, write to the Free
  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/

void print_pol(int *, int, int);
void print_pol_mpz(mpz_t *, int, int); 
void diff1(int *, int *, int, int, int); 
void diff2(int *, int *, int, int, int); 
void deriv_pol1(mpz_t *, mpz_t *, int, int);
void deriv_pol2(mpz_t *, mpz_t *, int, int);
int eval_mod(int *, int, int, int, int, int);
void eval_pol(mpz_t, mpz_t *, mpz_t, mpz_t, mpz_t, int, int);
int ** roots_mod_p (mpz_t *, mpz_t *, int *, int *, int, int);
int hensel(mpz_t **, int *, mpz_t *, mpz_t *, mpz_t, int, int); 

void Norm1 (mpz_t, mpz_t *, int);
int slz (mpz_t **, int *, mpfr_t *, mpz_t, mpz_t, int, int, mpfr_t, 
         mat_ZZ *, mat_ZZ *,	mat_ZZ *, mat_ZZ *, int, int, mpz_t, mpz_t,
	 mpz_t, int *, mpz_t *, mpz_t *);
int Check (mpz_t *, int, mpz_t, mpz_t, mpfr_t, mpfr_t, mpz_t, int);

